/*
 * Copyright (C) 2011-2015 David C. McCallum
 * For conditions of distribution and use, see the copyright notice in Dasyne.hpp
*/

#include "DEvent.hpp"
#include "DEngine.hpp"

using namespace std;
using namespace libdasyne;

DEvent::DEvent(DEngine *newEngine)
{
    engine = NULL;
    joinEngine(newEngine);
}//constructor

DEvent::DEvent(const DEvent &source)
{
    engine = NULL;
    joinEngine(source.engine);
}//copy constructor

DEvent::~DEvent(void)
{
    leaveEngine();
}//destructor

DEvent& DEvent::operator= (const DEvent &source)
{
    if (this != &source)
        joinEngine(source.engine);

    return *this;
}//=

void DEvent::reportEngineLost(DEngine *theEngine)
{
    if (engine != theEngine)
        DEngine::fatalError("DEvent::reportEngineLost(): that's not my engine!");

    engine = NULL;
}//reportEngineLost

void DEvent::joinEngine(DEngine *newEngine)
{
    leaveEngine();

    engine = newEngine;
    myIter = engine->addEvent(this);
}//joinEngine

void DEvent::leaveEngine(void)
{
    if (engine != NULL)
    {
        engine->removeEvent(myIter);
        engine = NULL;
    }//if engine
}//leaveEngine
