/*
 * Copyright (C) 2012-2015 David C. McCallum
 * For conditions of distribution and use, see the copyright notice in Dasyne.hpp
*/

#include "DFieldValue.hpp"

using namespace std;
using namespace libdasyne;

DFieldValue::DFieldValue(void)
{
}//constructor

DFieldValue::~DFieldValue(void)
{
}//destructor

//############### UINT8_T ###############

DField_UINT8_T* DField_UINT8_T::generate(void)
{
    return new DField_UINT8_T;
}//generate

void DField_UINT8_T::setValue(DBuffer &newValue)
{
    if (newValue.size() != sizeof(theValue))
        DEngine::fatalError("DField_UINT8_T::setValue(): invalid value size");

    newValue.extractVariable(0, theValue);
}//setValue

DBuffer DField_UINT8_T::getValue(void)
{
    DBuffer result;//the value to return

    result.appendVariable(theValue);

    return result;
}//getValue

uint8_t DField_UINT8_T::size(void)
{
    return sizeof(theValue);
}//size

//############### UINT16_T ###############

DField_UINT16_T* DField_UINT16_T::generate(void)
{
    return new DField_UINT16_T;
}//generate

void DField_UINT16_T::setValue(DBuffer &newValue)
{
    if (newValue.size() != sizeof(theValue))
        DEngine::fatalError("DField_UINT16_T::setValue(): invalid value size");

    newValue.extractVariable(0, theValue);
}//setValue

DBuffer DField_UINT16_T::getValue(void)
{
    DBuffer result;//the value to return

    result.appendVariable(theValue);

    return result;
}//getValue

uint8_t DField_UINT16_T::size(void)
{
    return sizeof(theValue);
}//size

//############### UINT32_T ###############

DField_UINT32_T* DField_UINT32_T::generate(void)
{
    return new DField_UINT32_T;
}//generate

void DField_UINT32_T::setValue(DBuffer &newValue)
{
    if (newValue.size() != sizeof(theValue))
        DEngine::fatalError("DField_UINT32_T::setValue(): invalid value size");

    newValue.extractVariable(0, theValue);
}//setValue

DBuffer DField_UINT32_T::getValue(void)
{
    DBuffer result;//the value to return

    result.appendVariable(theValue);

    return result;
}//getValue

uint8_t DField_UINT32_T::size(void)
{
    return sizeof(theValue);
}//size

//############### UINT64_T ###############

DField_UINT64_T* DField_UINT64_T::generate(void)
{
    return new DField_UINT64_T;
}//generate

void DField_UINT64_T::setValue(DBuffer &newValue)
{
    if (newValue.size() != sizeof(theValue))
        DEngine::fatalError("DField_UINT64_T::setValue(): invalid value size");

    newValue.extractVariable(0, theValue);
}//setValue

DBuffer DField_UINT64_T::getValue(void)
{
    DBuffer result;//the value to return

    result.appendVariable(theValue);

    return result;
}//getValue

uint8_t DField_UINT64_T::size(void)
{
    return sizeof(theValue);
}//size

//############### INT8_T ###############

DField_INT8_T* DField_INT8_T::generate(void)
{
    return new DField_INT8_T;
}//generate

void DField_INT8_T::setValue(DBuffer &newValue)
{
    if (newValue.size() != sizeof(theValue))
        DEngine::fatalError("DField_INT8_T::setValue(): invalid value size");

    newValue.extractVariable(0, theValue);
}//setValue

DBuffer DField_INT8_T::getValue(void)
{
    DBuffer result;//the value to return

    result.appendVariable(theValue);

    return result;
}//getValue

uint8_t DField_INT8_T::size(void)
{
    return sizeof(theValue);
}//size

//############### INT16_T ###############

DField_INT16_T* DField_INT16_T::generate(void)
{
    return new DField_INT16_T;
}//generate

void DField_INT16_T::setValue(DBuffer &newValue)
{
    if (newValue.size() != sizeof(theValue))
        DEngine::fatalError("DField_INT16_T::setValue(): invalid value size");

    newValue.extractVariable(0, theValue);
}//setValue

DBuffer DField_INT16_T::getValue(void)
{
    DBuffer result;//the value to return

    result.appendVariable(theValue);

    return result;
}//getValue

uint8_t DField_INT16_T::size(void)
{
    return sizeof(theValue);
}//size

//############### INT32_T ###############

DField_INT32_T* DField_INT32_T::generate(void)
{
    return new DField_INT32_T;
}//generate

void DField_INT32_T::setValue(DBuffer &newValue)
{
    if (newValue.size() != sizeof(theValue))
        DEngine::fatalError("DField_INT32_T::setValue(): invalid value size");

    newValue.extractVariable(0, theValue);
}//setValue

DBuffer DField_INT32_T::getValue(void)
{
    DBuffer result;//the value to return

    result.appendVariable(theValue);

    return result;
}//getValue

uint8_t DField_INT32_T::size(void)
{
    return sizeof(theValue);
}//size

//############### INT64_T ###############

DField_INT64_T* DField_INT64_T::generate(void)
{
    return new DField_INT64_T;
}//generate

void DField_INT64_T::setValue(DBuffer &newValue)
{
    if (newValue.size() != sizeof(theValue))
        DEngine::fatalError("DField_INT64_T::setValue(): invalid value size");

    newValue.extractVariable(0, theValue);
}//setValue

DBuffer DField_INT64_T::getValue(void)
{
    DBuffer result;//the value to return

    result.appendVariable(theValue);

    return result;
}//getValue

uint8_t DField_INT64_T::size(void)
{
    return sizeof(theValue);
}//size

//############### FLOAT ###############

DField_FLOAT* DField_FLOAT::generate(void)
{
    return new DField_FLOAT;
}//generate

void DField_FLOAT::setValue(DBuffer &newValue)
{
    if (newValue.size() != sizeof(theValue))
        DEngine::fatalError("DField_FLOAT::setValue(): invalid value size");

    newValue.extractVariable(0, theValue);
}//setValue

DBuffer DField_FLOAT::getValue(void)
{
    DBuffer result;//the value to return

    result.appendVariable(theValue);

    return result;
}//getValue

uint8_t DField_FLOAT::size(void)
{
    return sizeof(theValue);
}//size

//############### DOUBLE ###############

DField_DOUBLE* DField_DOUBLE::generate(void)
{
    return new DField_DOUBLE;
}//generate

void DField_DOUBLE::setValue(DBuffer &newValue)
{
    if (newValue.size() != sizeof(theValue))
        DEngine::fatalError("DField_DOUBLE::setValue(): invalid value size");

    newValue.extractVariable(0, theValue);
}//setValue

DBuffer DField_DOUBLE::getValue(void)
{
    DBuffer result;//the value to return

    result.appendVariable(theValue);

    return result;
}//getValue

uint8_t DField_DOUBLE::size(void)
{
    return sizeof(theValue);
}//size

//############### STRING ###############

DField_STRING* DField_STRING::generate(void)
{
    return new DField_STRING;
}//generate

void DField_STRING::setValue(DBuffer &newValue)
{
    theValue = newValue.toString();
}//setValue

DBuffer DField_STRING::getValue(void)
{
    DBuffer result;//the value to return

    result.appendString(theValue);

    return result;
}//getValue

uint8_t DField_STRING::size(void)
{
    DEngine::fatalError("DField_STRING::size(): the size is not a constant.");

    return sizeof(theValue);
}//size

//############### DBUFFER ###############

DField_DBUFFER* DField_DBUFFER::generate(void)
{
    return new DField_DBUFFER;
}//generate

void DField_DBUFFER::setValue(DBuffer &newValue)
{
    theValue = newValue;
}//setValue

DBuffer DField_DBUFFER::getValue(void)
{
    return theValue;
}//getValue

uint8_t DField_DBUFFER::size(void)
{
    DEngine::fatalError("DField_DBUFFER::size(): the size is not a constant.");

    return sizeof(theValue);
}//size
