/*
 * Copyright (C) 2011-2015 David C. McCallum
 * For conditions of distribution and use, see the copyright notice in Dasyne.hpp
*/

/* DESCRIPTION
  Implements event handling for the DDispatcher class. Calls DDispatcher::flush
  whenever the DEngine updates.
*/

#ifndef DFLUSHEVENT_HPP_INCLUDED
#define DFLUSHEVENT_HPP_INCLUDED

#include "DEvent.hpp"

namespace libdasyne
{
    class DDispatcher;

    class DFlushEvent : public DEvent
    {
        public:
            //constructor
            DFlushEvent(DEngine *newEngine,
                        DDispatcher *newClient);

            //destructor
            virtual ~DFlushEvent(void);

            //Event handler, called when the DEngine updates. Returns the number of events
            //dispatched, this should normally be zero or one.
            unsigned int update(void);

        private:
            //Pointer to the message client to notify when the engine updates
            DDispatcher *client;

    };//DFlushEvent
}//namespace libdasyne

#endif
