/*
 * Copyright (C) 2014-2015 David C. McCallum
 * For conditions of distribution and use, see the copyright notice in Dasyne.hpp
*/

#include "DUdpMessage.hpp"
#include "DBuffer.hpp"

using namespace libdasyne;
using namespace std;

DUdpMessage::DUdpMessage(const string &newAddress,
                         uint16_t newPort)
{
    ipAddress = newAddress;
    port = newPort;
    data = new DBuffer;
}//constructor

DUdpMessage::~DUdpMessage(void)
{
    delete data;
    data = NULL;
}//destructor

void DUdpMessage::setData(const DBuffer &newData)
{
    data->clear();
    data->append(newData);
}//setData

DBuffer* DUdpMessage::getData(void)
{
    return data;
}//getData

string DUdpMessage::getAddress(void)
{
    return ipAddress;
}//getAddress

uint16_t DUdpMessage::getPort(void)
{
    return port;
}//getPort
