/*
 * Copyright (C) 2014 David C. McCallum
 * For conditions of distribution and use, see the copyright notice in Dasyne.hpp
*/

/* DESCRIPTION
    Contains a single datagram to be sent over UDP. Used by the DUdpSocket class to implement
    its send queue.
*/

#ifndef DUDPMESSAGE_HPP_INCLUDED
#define DUDPMESSAGE_HPP_INCLUDED

#include "DEngine.hpp"

namespace libdasyne
{
    class DBuffer;

    class DUdpMessage : public DObject
    {
        public:
            //constructor
            DUdpMessage(const std::string &ipAddress,
                        uint16_t portNumber);

            //destructor
            ~DUdpMessage(void);

            //Set the data to be sent in this message
            void setData(const DBuffer &newData);

            //Accessors
            DBuffer* getData(void);
            std::string getAddress(void);
            uint16_t getPort(void);

        private:
            //The data in this message
            DBuffer *data;

            //The IP address to send to
            std::string ipAddress;

            //The port number to send to
            uint16_t port;

    };//DUdpMessage
}//namespace libdasyne

#endif
